<template>

    <div class="item">
        <div v-if="editNow" class="item-list form">
            <div class="info">
                <div class="form">
                    <item-input :labelForm="'Название'" v-model="item.name" ></item-input> 
                </div>
            </div>
            <div class="actions">
                <div class="btn btn-primary" @click="updateItem"><i class="fas fa-check"></i></div>
                <div class="btn btn-danger" @click="cancelEdit(item)"><i class="fas fa-times"></i></div>
            </div>
        </div>
        <div v-else class="item-list">
            <div class="info">
                <div class="name">
                    <div :listTask="item.list">{{item.name}}</div>
                </div>
            </div>
            <div class="actions">
                <div class="btn btn-default" @click="opened = !opened">
                    <i v-if="!opened" class="far fa-eye"></i>
                    <i v-else class="far fa-eye-slash"></i>
                </div>
                <div class="btn btn-info" @click="startEdit(item)"><i class="far fa-edit"></i></div>
                <div class="btn btn-danger" @click="deleteItem(item)"><i class="far fa-trash-alt"></i></div>
            </div>
        </div>
        <div v-if="opened" class="list-tasks">
            <todo-view :listTask="item.list" @update-tasks="updateItem"></todo-view>
        </div>

    </div>

</template>

<script>
    import itemInput from '@/components/formInput'
    import todoView from '@/views/todo/todoView'

    export default {
        name: "todoListItem",
        components: {
            itemInput,
            todoView
        },
        props: {
            item: {
                required: true,
                type: Object
            },
        },
        data() {
            return {
                editNow: false,
                opened: false
            }
        },
        methods: {
            deleteItem(item) {
                this.$emit("delete-task", item);
            },
            updateItem() {
                this.editNow = false;
                console.log('todoItem');
                this.$emit("update-item");
            },
            cancelEdit(item) {
                Object.assign(item, this._beforeEditingCache);
                this.editNow = false;

            },
            startEdit(item) {
                this._beforeEditingCache = Object.assign({}, item);
                this.editNow = true;
            },
        }
    }
</script>

<style lang="scss" scoped>

    .form {
        .item-form {
            width: 100%;
        }
    }

    .item {
        margin-bottom: 20px;
    }

    .item-list {
        margin: 0 0 -1px;
        padding: 20px;
        border: 1px solid #cecece;
        display: flex;
        align-items: flex-start;

        .ico {
            min-width: 50px;
            max-width: 50px;
            height: 50px;
            margin-right: 20px;
            border: 1px solid #cecece;
            color: #cecece;
            border-radius: 50%;
            display: flex;
            align-items: center;
            justify-content: center;
            font-size: 24px;
            cursor: pointer;
        }

        .info {
            width: 100%;

            .form {
                display: flex;
                margin-bottom: 15px;
            }

            .image {
                margin: -5px 0 15px;
                text-decoration: underline;
                color: #0a34b1;
                display: block;
                width: 100%;

                img {
                    max-width: 100%;
                }
            }
            .name {
                font-size: 16px;
                font-weight: 600;
                margin-bottom: 10px;
                line-height: 20px;
            }
            .bottom-info {
                display: flex;
                align-items: center;
                width: 100%;

                .edited {
                    color: #a5a5a5;
                    font-style: italic;
                    margin-left: auto;
                }
            }

        }
        .actions {
            min-width: 125px;
            max-width: 125px;
            text-align: right;
            margin-left: 10px;

            .btn {
                margin: 1px;
                width: 35px;

                &:hover {
                    opacity: 1;
                }

                &.btn-info {
                    padding-left: 12px !important;
                }
            }
        }

        &.done {

            .ico {
                border-color: #158615;
                color: #158615;
            }
            .info {
                opacity: .3;
            }
        }
    }
</style>